/* utils.h
 * Wed Sep 28 17:41:45 PDT 2005
 * staka
 *
 * utility functions
 */

#ifndef __UTILS__
#define __UTILS__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <zlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#ifdef CHECKMALLOC
#include "check_malloc.h"
#endif

typedef struct __fpfn__ {
  char *path;
  FILE *fp;
} FPFN;

void *m_malloc(size_t size);
void *m_realloc(void *ptr, size_t size);
void m_free(void *ptr);

int isLittle(void);
void SwapInt32IL(int *p);
void SwapFloat32IL(float *p);

char *m_strdup(const char *s);
char *m_chomp(char *str);

gzFile m_gzopen(const char *path, const char *mode);
int m_gzclose(gzFile stream);

FILE *m_fopen(const char *path, const char *mode);
FPFN *fnopen(const char *path, const char *mode);
int m_fclose(FILE *stream);
int fnclose(FPFN *fpfn);
size_t m_fread(void *ptr, size_t size, size_t nmemb, FILE *stream, char *fname);
size_t fnread(void *ptr, size_t size, size_t nmemb, FPFN *fpfn);
size_t fnwrite(const void *ptr, size_t size, size_t nmemb, FPFN *fpfn);
void m_fgets(char *s, int size, FILE *stream);
void fngets(char *s, int size, FPFN *fpfn);

int m_lock_fcntl(FILE *fp);
int m_unlock_fcntl(FILE *fp);

#endif /* __UTILS__ */

